import java.awt
import java.awt.event
import java.io
import java.lang
import java.util
import javax.swing
import javax.swing.table
import org.apache.log4j.lf5
import org.apache.log4j.lf5.util
import org.apache.log4j.lf5.viewer.categoryexplorer
import org.apache.log4j.lf5.viewer.configure
import typing



class FilteredLogTableModel(javax.swing.table.AbstractTableModel):
    def __init__(self): ...
    def addLogRecord(self, logRecord: org.apache.log4j.lf5.LogRecord) -> bool: ...
    def clear(self) -> None: ...
    def fastRefresh(self) -> None: ...
    def getColumnCount(self) -> int: ...
    def getColumnName(self, int: int) -> str: ...
    def getLogRecordFilter(self) -> org.apache.log4j.lf5.LogRecordFilter: ...
    def getRowCount(self) -> int: ...
    def getTotalRowCount(self) -> int: ...
    def getValueAt(self, int: int, int2: int) -> typing.Any: ...
    def refresh(self) -> None: ...
    def setLogRecordFilter(self, logRecordFilter: org.apache.log4j.lf5.LogRecordFilter) -> None: ...
    def setMaxNumberOfLogRecords(self, int: int) -> None: ...

class LF5SwingUtils:
    def __init__(self): ...
    @staticmethod
    def makeScrollBarTrack(adjustable: java.awt.Adjustable) -> None: ...
    @staticmethod
    def makeVerticalScrollBarTrack(jScrollPane: javax.swing.JScrollPane) -> None: ...
    @staticmethod
    def selectRow(int: int, jTable: javax.swing.JTable, jScrollPane: javax.swing.JScrollPane) -> None: ...

class LogBrokerMonitor:
    DETAILED_VIEW: typing.ClassVar[str] = ...
    def __init__(self, list: java.util.List): ...
    def addDisplayedProperty(self, object: typing.Any) -> None: ...
    def addMessage(self, logRecord: org.apache.log4j.lf5.LogRecord) -> None: ...
    def dispose(self) -> None: ...
    def getBaseFrame(self) -> javax.swing.JFrame: ...
    def getCallSystemExitOnClose(self) -> bool: ...
    def getCategoryExplorerTree(self) -> org.apache.log4j.lf5.viewer.categoryexplorer.CategoryExplorerTree: ...
    def getDateFormatManager(self) -> org.apache.log4j.lf5.util.DateFormatManager: ...
    def getLogLevelMenuItems(self) -> java.util.Map: ...
    def getLogTableColumnMenuItems(self) -> java.util.Map: ...
    def getNDCTextFilter(self) -> str: ...
    def getTableColumnMenuItem(self, logTableColumn: 'LogTableColumn') -> javax.swing.JCheckBoxMenuItem: ...
    def hide(self) -> None: ...
    def setCallSystemExitOnClose(self, boolean: bool) -> None: ...
    def setDateFormatManager(self, dateFormatManager: org.apache.log4j.lf5.util.DateFormatManager) -> None: ...
    def setFontSize(self, int: int) -> None: ...
    def setFrameSize(self, int: int, int2: int) -> None: ...
    def setMaxNumberOfLogRecords(self, int: int) -> None: ...
    def setNDCLogRecordFilter(self, string: str) -> None: ...
    def setTitle(self, string: str) -> None: ...
    @typing.overload
    def show(self) -> None: ...
    @typing.overload
    def show(self, int: int) -> None: ...

class LogFactor5Dialog(javax.swing.JDialog):
    @typing.overload
    def show(self, boolean: bool) -> None: ...
    @typing.overload
    def show(self) -> None: ...

class LogTable(javax.swing.JTable):
    def __init__(self, jTextArea: javax.swing.JTextArea): ...
    def clearLogRecords(self) -> None: ...
    def getDateFormatManager(self) -> org.apache.log4j.lf5.util.DateFormatManager: ...
    def getFilteredLogTableModel(self) -> FilteredLogTableModel: ...
    def setDateFormatManager(self, dateFormatManager: org.apache.log4j.lf5.util.DateFormatManager) -> None: ...
    def setDetailedView(self) -> None: ...
    def setFont(self, font: java.awt.Font) -> None: ...
    def setView(self, list: java.util.List) -> None: ...

class LogTableColumn(java.io.Serializable):
    DATE: typing.ClassVar['LogTableColumn'] = ...
    THREAD: typing.ClassVar['LogTableColumn'] = ...
    MESSAGE_NUM: typing.ClassVar['LogTableColumn'] = ...
    LEVEL: typing.ClassVar['LogTableColumn'] = ...
    NDC: typing.ClassVar['LogTableColumn'] = ...
    CATEGORY: typing.ClassVar['LogTableColumn'] = ...
    MESSAGE: typing.ClassVar['LogTableColumn'] = ...
    LOCATION: typing.ClassVar['LogTableColumn'] = ...
    THROWN: typing.ClassVar['LogTableColumn'] = ...
    def __init__(self, string: str): ...
    def equals(self, object: typing.Any) -> bool: ...
    def getLabel(self) -> str: ...
    @staticmethod
    def getLogTableColumnArray() -> typing.List['LogTableColumn']: ...
    @staticmethod
    def getLogTableColumns() -> java.util.List: ...
    def hashCode(self) -> int: ...
    def toString(self) -> str: ...
    @staticmethod
    def valueOf(string: str) -> 'LogTableColumn': ...

class LogTableColumnFormatException(java.lang.Exception):
    def __init__(self, string: str): ...

class LogTableModel(javax.swing.table.DefaultTableModel):
    def __init__(self, objectArray: typing.List[typing.Any], int: int): ...
    def isCellEditable(self, int: int, int2: int) -> bool: ...

class LogTableRowRenderer(javax.swing.table.DefaultTableCellRenderer):
    def __init__(self): ...
    def getTableCellRendererComponent(self, jTable: javax.swing.JTable, object: typing.Any, boolean: bool, boolean2: bool, int: int, int2: int) -> java.awt.Component: ...

class TrackingAdjustmentListener(java.awt.event.AdjustmentListener):
    def __init__(self): ...
    def adjustmentValueChanged(self, adjustmentEvent: java.awt.event.AdjustmentEvent) -> None: ...

class LogFactor5ErrorDialog(LogFactor5Dialog):
    def __init__(self, jFrame: javax.swing.JFrame, string: str): ...

class LogFactor5InputDialog(LogFactor5Dialog):
    SIZE: typing.ClassVar[int] = ...
    @typing.overload
    def __init__(self, jFrame: javax.swing.JFrame, string: str, string2: str): ...
    @typing.overload
    def __init__(self, jFrame: javax.swing.JFrame, string: str, string2: str, int: int): ...
    def getText(self) -> str: ...

class LogFactor5LoadingDialog(LogFactor5Dialog):
    def __init__(self, jFrame: javax.swing.JFrame, string: str): ...


class __module_protocol__(typing.Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("org.apache.log4j.lf5.viewer")``.

    FilteredLogTableModel: typing.Type[FilteredLogTableModel]
    LF5SwingUtils: typing.Type[LF5SwingUtils]
    LogBrokerMonitor: typing.Type[LogBrokerMonitor]
    LogFactor5Dialog: typing.Type[LogFactor5Dialog]
    LogFactor5ErrorDialog: typing.Type[LogFactor5ErrorDialog]
    LogFactor5InputDialog: typing.Type[LogFactor5InputDialog]
    LogFactor5LoadingDialog: typing.Type[LogFactor5LoadingDialog]
    LogTable: typing.Type[LogTable]
    LogTableColumn: typing.Type[LogTableColumn]
    LogTableColumnFormatException: typing.Type[LogTableColumnFormatException]
    LogTableModel: typing.Type[LogTableModel]
    LogTableRowRenderer: typing.Type[LogTableRowRenderer]
    TrackingAdjustmentListener: typing.Type[TrackingAdjustmentListener]
    categoryexplorer: org.apache.log4j.lf5.viewer.categoryexplorer.__module_protocol__
    configure: org.apache.log4j.lf5.viewer.configure.__module_protocol__
